diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/theme-editor.php ./wordpress-3.4/wp-admin/theme-editor.php
*** ./wordpress-3.3.2/wp-admin/theme-editor.php	2011-11-30 22:51:35.000000000 -0600
--- ./wordpress-3.4/wp-admin/theme-editor.php	2012-05-22 10:25:35.000000000 -0500
***************
*** 42,121 ****
  	'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
  );
  
! wp_reset_vars(array('action', 'redirect', 'profile', 'error', 'warning', 'a', 'file', 'theme', 'dir'));
  
! $themes = get_themes();
! 
! if (empty($theme)) {
! 	$theme = get_current_theme();
! } else {
! 	$theme = stripslashes($theme);
! }
! 
! if ( ! isset($themes[$theme]) )
! 	wp_die(__('The requested theme does not exist.'));
! 
! $allowed_files = array_merge( $themes[$theme]['Stylesheet Files'], $themes[$theme]['Template Files'] );
  
  if ( empty( $file ) ) {
! 	if ( false !== array_search( $themes[$theme]['Stylesheet Dir'] . '/style.css', $allowed_files ) )
! 		$file = $themes[$theme]['Stylesheet Dir'] . '/style.css';
! 	else
! 		$file = $allowed_files[0];
  } else {
! 	$file = stripslashes($file);
! 	if ( 'theme' == $dir ) {
! 		$file = dirname(dirname($themes[$theme]['Template Dir'])) . $file ;
! 	} else if ( 'style' == $dir) {
! 		$file = dirname(dirname($themes[$theme]['Stylesheet Dir'])) . $file ;
! 	}
  }
  
! validate_file_to_edit($file, $allowed_files);
! $scrollto = isset($_REQUEST['scrollto']) ? (int) $_REQUEST['scrollto'] : 0;
! $file_show = basename( $file );
! 
! switch($action) {
  
  case 'update':
! 
! 	check_admin_referer('edit-theme_' . $file . $theme);
! 
! 	$newcontent = stripslashes($_POST['newcontent']);
! 	$theme = urlencode($theme);
! 	if (is_writeable($file)) {
  		//is_writable() not always reliable, check return value. see comments @ http://uk.php.net/is_writable
! 		$f = fopen($file, 'w+');
! 		if ($f !== FALSE) {
! 			fwrite($f, $newcontent);
! 			fclose($f);
! 			$location = "theme-editor.php?file=$file&theme=$theme&a=te&scrollto=$scrollto";
! 		} else {
! 			$location = "theme-editor.php?file=$file&theme=$theme&scrollto=$scrollto";
  		}
- 	} else {
- 		$location = "theme-editor.php?file=$file&theme=$theme&scrollto=$scrollto";
  	}
! 
! 	$location = wp_kses_no_null($location);
! 	$strip = array('%0d', '%0a', '%0D', '%0A');
! 	$location = _deep_replace($strip, $location);
! 	header("Location: $location");
! 	exit();
! 
  break;
  
  default:
  
! 	require_once(ABSPATH . 'wp-admin/admin-header.php');
  
! 	update_recently_edited($file);
  
! 	if ( !is_file($file) )
! 		$error = 1;
  
  	$content = '';
! 	if ( !$error && filesize($file) > 0 ) {
  		$f = fopen($file, 'r');
  		$content = fread($f, filesize($file));
  
--- 42,109 ----
  	'<p>' . __('<a href="http://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
  );
  
! wp_reset_vars( array( 'action', 'error', 'file', 'theme' ) );
  
! if ( $theme )
! 	$stylesheet = urldecode( $theme );
! else
! 	$stylesheet = get_stylesheet();
! 
! $theme = wp_get_theme( $stylesheet );
! 
! if ( ! $theme->exists() )
! 	wp_die( __( 'The requested theme does not exist.' ) );
! 
! if ( $theme->errors() && 'theme_no_stylesheet' == $theme->errors()->get_error_code() )
! 	wp_die( __( 'The requested theme does not exist.' ) . ' ' . $theme->errors()->get_error_message() );
! 
! $allowed_files = $theme->get_files( 'php', 1 );
! $has_templates = ! empty( $allowed_files );
! $style_files = $theme->get_files( 'css' );
! $allowed_files['style.css'] = $style_files['style.css'];
! $allowed_files += $style_files;
  
  if ( empty( $file ) ) {
! 	$relative_file = 'style.css';
! 	$file = $allowed_files['style.css'];
  } else {
! 	$relative_file = urldecode( stripslashes( $file ) );
! 	$file = $theme->get_stylesheet_directory() . '/' . $relative_file;
  }
  
! validate_file_to_edit( $file, $allowed_files );
! $scrollto = isset( $_REQUEST['scrollto'] ) ? (int) $_REQUEST['scrollto'] : 0;
  
+ switch( $action ) {
  case 'update':
! 	check_admin_referer( 'edit-theme_' . $file . $stylesheet );
! 	$newcontent = stripslashes( $_POST['newcontent'] );
! 	$location = 'theme-editor.php?file=' . urlencode( $relative_file ) . '&theme=' . urlencode( $stylesheet ) . '&scrollto=' . $scrollto;
! 	if ( is_writeable( $file ) ) {
  		//is_writable() not always reliable, check return value. see comments @ http://uk.php.net/is_writable
! 		$f = fopen( $file, 'w+' );
! 		if ( $f !== false ) {
! 			fwrite( $f, $newcontent );
! 			fclose( $f );
! 			$location .= '&updated=true';
! 			$theme->cache_delete();
  		}
  	}
! 	wp_redirect( $location );
! 	exit;
  break;
  
  default:
  
! 	require_once( ABSPATH . 'wp-admin/admin-header.php' );
  
! 	update_recently_edited( $file );
  
! 	if ( ! is_file( $file ) )
! 		$error = true;
  
  	$content = '';
! 	if ( ! $error && filesize( $file ) > 0 ) {
  		$f = fopen($file, 'r');
  		$content = fread($f, filesize($file));
  
***************
*** 134,147 ****
  	}
  
  	?>
! <?php if (isset($_GET['a'])) : ?>
!  <div id="message" class="updated"><p><?php _e('File edited successfully.') ?></p></div>
  <?php endif;
  
! $description = get_file_description($file);
! $desc_header = ( $description != $file_show ) ? "$description <span>($file_show)</span>" : $file_show;
! 
! $is_child_theme = $themes[$theme]['Template'] != $themes[$theme]['Stylesheet'];
  ?>
  <div class="wrap">
  <?php screen_icon(); ?>
--- 122,135 ----
  	}
  
  	?>
! <?php if ( isset( $_GET['updated'] ) ) : ?>
!  <div id="message" class="updated"><p><?php _e( 'File edited successfully.' ) ?></p></div>
  <?php endif;
  
! $description = get_file_description( $file );
! $file_show = array_search( $file, array_filter( $allowed_files ) );
! if ( $description != $file_show )
! 	$description .= ' <span>(' . $file_show . ')</span>';
  ?>
  <div class="wrap">
  <?php screen_icon(); ?>
***************
*** 149,167 ****
  
  <div class="fileedit-sub">
  <div class="alignleft">
! <h3><?php echo $themes[$theme]['Name'] . ': ' . $desc_header; ?></h3>
  </div>
  <div class="alignright">
  	<form action="theme-editor.php" method="post">
  		<strong><label for="theme"><?php _e('Select theme to edit:'); ?> </label></strong>
  		<select name="theme" id="theme">
  <?php
! 	foreach ($themes as $a_theme) {
! 	$theme_name = $a_theme['Name'];
! 	if ($theme_name == $theme) $selected = " selected='selected'";
! 	else $selected = '';
! 	$theme_name = esc_attr($theme_name);
! 	echo "\n\t<option value=\"$theme_name\" $selected>$theme_name</option>";
  }
  ?>
  		</select>
--- 137,155 ----
  
  <div class="fileedit-sub">
  <div class="alignleft">
! <h3><?php echo $theme->display('Name'); if ( $description ) echo ': ' . $description; ?></h3>
  </div>
  <div class="alignright">
  	<form action="theme-editor.php" method="post">
  		<strong><label for="theme"><?php _e('Select theme to edit:'); ?> </label></strong>
  		<select name="theme" id="theme">
  <?php
! foreach ( wp_get_themes( array( 'errors' => null ) ) as $a_stylesheet => $a_theme ) {
! 	if ( $a_theme->errors() && 'theme_no_stylesheet' == $a_theme->errors()->get_error_code() )
! 		continue;
! 
! 	$selected = $a_stylesheet == $stylesheet ? ' selected="selected"' : '';
! 	echo "\n\t" . '<option value="' . esc_attr( $a_stylesheet ) . '"' . $selected . '>' . $a_theme->display('Name') . '</option>';
  }
  ?>
  		</select>
***************
*** 170,247 ****
  </div>
  <br class="clear" />
  </div>
  	<div id="templateside">
  <?php
! if ($allowed_files) :
  ?>
  	<h3><?php _e('Templates'); ?></h3>
! 	<?php if ( $is_child_theme ) : ?>
! 	<p class="howto"><?php printf( __( 'This child theme inherits templates from a parent theme, %s.' ), $themes[$theme]['Parent Theme'] ); ?></p>
  	<?php endif; ?>
  	<ul>
  <?php
! 	$template_mapping = array();
! 	$template_dir = $themes[$theme]['Template Dir'];
! 	foreach ( $themes[$theme]['Template Files'] as $template_file ) {
! 		// Don't show parent templates.
! 		if ( $is_child_theme && strpos( $template_file, trailingslashit( $template_dir ) ) === 0 )
! 			continue;
! 
! 		$description = trim( get_file_description($template_file) );
! 		$template_show = basename($template_file);
! 		$filedesc = ( $description != $template_file ) ? "$description<br /><span class='nonessential'>($template_show)</span>" : "$description";
! 		$filedesc = ( $template_file == $file ) ? "<span class='highlight'>$description<br /><span class='nonessential'>($template_show)</span></span>" : $filedesc;
! 		$template_mapping[ $description ] = array( _get_template_edit_filename($template_file, $template_dir), $filedesc );
! 	}
! 	ksort( $template_mapping );
! 	while ( list( $template_sorted_key, list( $template_file, $filedesc ) ) = each( $template_mapping ) ) :
! 	?>
! 		<li><a href="theme-editor.php?file=<?php echo urlencode( $template_file ) ?>&amp;theme=<?php echo urlencode( $theme ) ?>&amp;dir=theme"><?php echo $filedesc ?></a></li>
! <?php endwhile; ?>
! 	</ul>
! 	<h3><?php /* translators: Theme stylesheets in theme editor */ _ex('Styles', 'Theme stylesheets in theme editor'); ?></h3>
! 	<ul>
  <?php
! 	$template_mapping = array();
! 	$stylesheet_dir = $themes[$theme]['Stylesheet Dir'];
! 	foreach ( $themes[$theme]['Stylesheet Files'] as $style_file ) {
! 		// Don't show parent styles.
! 		if ( $is_child_theme && strpos( $style_file, trailingslashit( $template_dir ) ) === 0 )
! 			continue;
! 
! 		$description = trim( get_file_description($style_file) );
! 		$style_show = basename($style_file);
! 		$filedesc = ( $description != $style_file ) ? "$description<br /><span class='nonessential'>($style_show)</span>" : "$description";
! 		$filedesc = ( $style_file == $file ) ? "<span class='highlight'>$description<br /><span class='nonessential'>($style_show)</span></span>" : $filedesc;
! 		$template_mapping[ $description ] = array( _get_template_edit_filename($style_file, $stylesheet_dir), $filedesc );
! 	}
! 	ksort( $template_mapping );
! 	while ( list( $template_sorted_key, list( $style_file, $filedesc ) ) = each( $template_mapping ) ) :
! 		?>
! 		<li><a href="theme-editor.php?file=<?php echo urlencode( $style_file ) ?>&amp;theme=<?php echo urlencode($theme) ?>&amp;dir=style"><?php echo $filedesc ?></a></li>
! <?php endwhile; ?>
! 	</ul>
  <?php endif; ?>
  </div>
! <?php if (!$error) { ?>
  	<form name="template" id="template" action="theme-editor.php" method="post">
! 	<?php wp_nonce_field('edit-theme_' . $file . $theme) ?>
! 		 <div><textarea cols="70" rows="25" name="newcontent" id="newcontent" tabindex="1"><?php echo $content ?></textarea>
  		 <input type="hidden" name="action" value="update" />
! 		 <input type="hidden" name="file" value="<?php echo esc_attr($file) ?>" />
! 		 <input type="hidden" name="theme" value="<?php echo esc_attr($theme) ?>" />
  		 <input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
  		 </div>
! 	<?php if ( isset($functions ) && count($functions) ) { ?>
  		<div id="documentation" class="hide-if-no-js">
  		<label for="docs-list"><?php _e('Documentation:') ?></label>
  		<?php echo $docs_select; ?>
  		<input type="button" class="button" value=" <?php esc_attr_e( 'Lookup' ); ?> " onclick="if ( '' != jQuery('#docs-list').val() ) { window.open( 'http://api.wordpress.org/core/handbook/1.0/?function=' + escape( jQuery( '#docs-list' ).val() ) + '&amp;locale=<?php echo urlencode( get_locale() ) ?>&amp;version=<?php echo urlencode( $wp_version ) ?>&amp;redirect=true'); }" />
  		</div>
! 	<?php } ?>
  
  		<div>
! 		<?php if ( is_child_theme() && ! $is_child_theme && $themes[$theme]['Template'] == get_option('template') ) : ?>
  			<p><?php if ( is_writeable( $file ) ) { ?><strong><?php _e( 'Caution:' ); ?></strong><?php } ?>
  			<?php _e( 'This is a file in your current parent theme.' ); ?></p>
  		<?php endif; ?>
--- 158,219 ----
  </div>
  <br class="clear" />
  </div>
+ <?php
+ if ( $theme->errors() )
+ 	echo '<div class="error"><p><strong>' . __( 'This theme is broken.' ) . '</strong> ' . $theme->errors()->get_error_message() . '</p></div>';
+ ?>
  	<div id="templateside">
  <?php
! if ( $allowed_files ) :
! 	if ( $has_templates || $theme->parent() ) :
  ?>
  	<h3><?php _e('Templates'); ?></h3>
! 	<?php if ( $theme->parent() ) : ?>
! 	<p class="howto"><?php printf( __( 'This child theme inherits templates from a parent theme, %s.' ), '<a href="' . self_admin_url('theme-editor.php?theme=' . urlencode( $theme->get_template() ) ) . '">' . $theme->parent()->display('Name') . '</a>' ); ?></p>
  	<?php endif; ?>
  	<ul>
  <?php
! 	endif;
! 
! 	foreach ( $allowed_files as $filename => $absolute_filename ) :
! 		if ( 'style.css' == $filename )
! 			echo "\t</ul>\n\t<h3>" . _x( 'Styles', 'Theme stylesheets in theme editor' ) . "</h3>\n\t<ul>\n";
! 
! 		$file_description = get_file_description( $absolute_filename );
! 		if ( $file_description != basename( $filename ) )
! 			$file_description .= '<br /><span class="nonessential">(' . $filename . ')</span>';
! 
! 		if ( $absolute_filename == $file )
! 			$file_description = '<span class="highlight">' . $file_description . '</span>';
! ?>
! 		<li><a href="theme-editor.php?file=<?php echo urlencode( $filename ) ?>&amp;theme=<?php echo urlencode( $stylesheet ) ?>"><?php echo $file_description; ?></a></li>
  <?php
! 	endforeach;
! ?>
! </ul>
  <?php endif; ?>
  </div>
! <?php if ( $error ) :
! 	echo '<div class="error"><p>' . __('Oops, no such file exists! Double check the name and try again, merci.') . '</p></div>';
! else : ?>
  	<form name="template" id="template" action="theme-editor.php" method="post">
! 	<?php wp_nonce_field( 'edit-theme_' . $file . $stylesheet ); ?>
! 		 <div><textarea cols="70" rows="30" name="newcontent" id="newcontent" tabindex="1"><?php echo $content ?></textarea>
  		 <input type="hidden" name="action" value="update" />
! 		 <input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
! 		 <input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
  		 <input type="hidden" name="scrollto" id="scrollto" value="<?php echo $scrollto; ?>" />
  		 </div>
! 	<?php if ( ! empty( $functions ) ) : ?>
  		<div id="documentation" class="hide-if-no-js">
  		<label for="docs-list"><?php _e('Documentation:') ?></label>
  		<?php echo $docs_select; ?>
  		<input type="button" class="button" value=" <?php esc_attr_e( 'Lookup' ); ?> " onclick="if ( '' != jQuery('#docs-list').val() ) { window.open( 'http://api.wordpress.org/core/handbook/1.0/?function=' + escape( jQuery( '#docs-list' ).val() ) + '&amp;locale=<?php echo urlencode( get_locale() ) ?>&amp;version=<?php echo urlencode( $wp_version ) ?>&amp;redirect=true'); }" />
  		</div>
! 	<?php endif; ?>
  
  		<div>
! 		<?php if ( is_child_theme() && $theme->get_stylesheet() == get_template() ) : ?>
  			<p><?php if ( is_writeable( $file ) ) { ?><strong><?php _e( 'Caution:' ); ?></strong><?php } ?>
  			<?php _e( 'This is a file in your current parent theme.' ); ?></p>
  		<?php endif; ?>
***************
*** 254,262 ****
  		</div>
  	</form>
  <?php
! 	} else {
! 		echo '<div class="error"><p>' . __('Oops, no such file exists! Double check the name and try again, merci.') . '</p></div>';
! 	}
  ?>
  <br class="clear" />
  </div>
--- 226,232 ----
  		</div>
  	</form>
  <?php
! endif; // $error
  ?>
  <br class="clear" />
  </div>
***************
*** 272,275 ****
  break;
  }
  
! include(ABSPATH . "wp-admin/admin-footer.php");
--- 242,245 ----
  break;
  }
  
! include(ABSPATH . 'wp-admin/admin-footer.php' );
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/theme-install.php ./wordpress-3.4/wp-admin/theme-install.php
*** ./wordpress-3.3.2/wp-admin/theme-install.php	2011-11-30 20:22:07.000000000 -0600
--- ./wordpress-3.4/wp-admin/theme-install.php	2012-06-01 08:13:32.000000000 -0500
***************
*** 30,51 ****
  	$submenu_file = 'themes.php';
  
  wp_enqueue_script( 'theme-install' );
! 
! add_thickbox();
! wp_enqueue_script( 'theme-preview' );
  
  $body_id = $tab;
  
  do_action('install_themes_pre_' . $tab); //Used to override the general interface, Eg, install or theme information.
  
! $help = '<p>' . sprintf(__('You can find additional themes for your site by using the Theme Browser/Installer on this screen, which will display themes from the <a href="%s" target="_blank">WordPress.org Theme Directory</a>. These themes are designed and developed by third parties, are available free of charge, and are compatible with the license WordPress uses.'), 'http://wordpress.org/extend/themes/') . '</p>';
! $help .= '<p>' . __('You can Search for themes by keyword, author, or tag, or can get more specific and search by criteria listed in the feature filter. Alternately, you can browse the themes that are Featured, Newest, or Recently Updated. When you find a theme you like, you can preview it or install it.') . '</p>';
! $help .= '<p>' . __('You can Upload a theme manually if you have already downloaded its ZIP archive onto your computer (make sure it is from a trusted and original source). You can also do it the old-fashioned way and copy a downloaded theme&#8217;s folder via FTP into your <code>/wp-content/themes</code> directory.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'overview',
  	'title'   => __('Overview'),
! 	'content' => $help
  ) );
  
  get_current_screen()->set_help_sidebar(
--- 30,60 ----
  	$submenu_file = 'themes.php';
  
  wp_enqueue_script( 'theme-install' );
! wp_enqueue_script( 'theme' );
  
  $body_id = $tab;
  
  do_action('install_themes_pre_' . $tab); //Used to override the general interface, Eg, install or theme information.
  
! $help_overview =
! 	'<p>' . sprintf(__('You can find additional themes for your site by using the Theme Browser/Installer on this screen, which will display themes from the <a href="%s" target="_blank">WordPress.org Theme Directory</a>. These themes are designed and developed by third parties, are available free of charge, and are compatible with the license WordPress uses.'), 'http://wordpress.org/extend/themes/') . '</p>' .
! 	'<p>' . __('You can Search for themes by keyword, author, or tag, or can get more specific and search by criteria listed in the feature filter. Alternately, you can browse the themes that are Featured, Newest, or Recently Updated. When you find a theme you like, you can preview it or install it.') . '</p>' .
! 	'<p>' . __('You can Upload a theme manually if you have already downloaded its ZIP archive onto your computer (make sure it is from a trusted and original source). You can also do it the old-fashioned way and copy a downloaded theme&#8217;s folder via FTP into your <code>/wp-content/themes</code> directory.') . '</p>';
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'overview',
  	'title'   => __('Overview'),
! 	'content' => $help_overview
! ) );
! 
! $help_installing =
! 	'<p>' . __('Once you have generated a list of themes, you can preview and install any of them. Click on the thumbnail of the theme you&#8217;re interested in previewing. It will open up in a full-screen Preview page to give you a better idea of how that theme will look.') . '</p>' .
! 	'<p>' . __('To install the theme so you can preview it with your site&#8217;s content and customize its theme options, click the "Install" button at the top of the left-hand pane. The theme files will be downloaded to your website automatically. When this is complete, the theme is now available for activation, which you can do by clicking the "Activate" link, or by navigating to your Installed Themes page and clicking the "Live Preview" link under any installed theme&#8217;s thumbnail image.') . '</p>';
! 
! get_current_screen()->add_help_tab( array(
! 	'id'      => 'installing',
! 	'title'   => __('Previewing and Installing'),
! 	'content' => $help_installing
  ) );
  
  get_current_screen()->set_help_sidebar(
